# Name: emm_random.py
#
# Authors: F. Tarissan
# Purpose: generate dynamical graph relying on edge-markovian model
#
# PARAM : n, p, d, T
#             n = size graph
#             p = proba creating edge
#             d = proba deleteing edge
#             T = last time stamp
####################################################

import sys
from random import *

#####################
# GENERAL FUNCTIONS #
#####################


def generate_poss_edge(n):
	l=[]
	for x in range(1,n+1):
		for y in range(x+1,n+1):
			l.append((x,y))
	return l

# Main loop
if __name__ == '__main__':
	# handling arguments
	if len(sys.argv) != 5:
		sys.stderr.write("Usage: %s n p d T\n"%sys.argv[0])
		sys.exit(1)

	n=int(sys.argv[1])
	p=float(sys.argv[2])
	d=float(sys.argv[3])
	T=int(sys.argv[4])

	exist_edge=[]
	poss_edge=generate_poss_edge(n)

	t=0
	for t in range(T):
		add=[]
		rem=[]

		for e in exist_edge:
			if random()<=d:
				print t,e[0],e[1],"S"
				rem.append(e)

		for e in poss_edge:
			if random()<=p:
				print t,e[0],e[1],"A"
				add.append(e)

		map(lambda x:poss_edge.remove(x),add)
		map(lambda x:exist_edge.remove(x),rem)

		exist_edge.extend(add)
		poss_edge.extend(rem)

	for e in exist_edge:
		print t,e[0],e[1],"S"
